"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  render: true,
  cleanup: true
};
exports.cleanup = exports.render = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _domTestingLibrary = require("dom-testing-library");

Object.keys(_domTestingLibrary).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _domTestingLibrary[key];
    }
  });
});
const mountedContainers = new Set();

const render = (Component, _ref = {}) => {
  let {
    target
  } = _ref,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["target"]);

  if (!target) {
    target = document.body.appendChild(document.createElement('div'));
  }

  const component = new Component((0, _extends2.default)({}, options, {
    target
  }));
  mountedContainers.add({
    target,
    component
  });
  return (0, _extends2.default)({
    component,
    // eslint-disable-next-line no-console
    debug: (el = document.body) => console.log((0, _domTestingLibrary.prettyDOM)(el))
  }, (0, _domTestingLibrary.getQueriesForElement)(document.body));
};

exports.render = render;

const cleanupAtContainer = container => {
  const {
    target,
    component
  } = container;
  component.$destroy();
  /* istanbul ignore else  */

  if (target.parentNode === document.body) {
    document.body.removeChild(target);
  }

  mountedContainers.delete(container);
};

const cleanup = () => {
  mountedContainers.forEach(cleanupAtContainer);
};

exports.cleanup = cleanup;